using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace RiskAnalysis
{
	/// <summary>
	/// Summary description for HazopConfigControl.
	/// </summary>
	public class HazopConfigControl : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.Button addprofile;
		private System.Windows.Forms.ListView profileview;
		private System.Windows.Forms.Button addstudy;
		private System.Windows.Forms.ListView studynodeview;
		private HazopTransformationProfileManager config;
		private DataTable profiledata;
		private DataTable digramtypes;
		private DataTable studynodedata;
		private DataTable parameterdata;
		private DataTable guideworddata;
		private DataTable entitydata;
		private System.Windows.Forms.TextBox tbprofilename;
		private System.Windows.Forms.ListBox lbdiagramtype;
		private System.Windows.Forms.ListView parameterview;
        private System.Windows.Forms.ListView guidewordview;

		Validator validator = new Validator();

		int selectedguideword = -1;
		int selectedparameter = -1;
		int selectedstudynode = -1;
		int selectedprofile = -1;
		int selecteddiagramtype = -1;

		private System.Windows.Forms.Button deletebutton;
		private System.Windows.Forms.Button deletestudy;
		private System.Windows.Forms.Button parameterdelete;
		private System.Windows.Forms.Button deleteguide;
		private System.Windows.Forms.Button addguide;
		private System.Windows.Forms.TextBox tbguidew;
		private System.Windows.Forms.TextBox lbstudynode;
		private System.Windows.Forms.TextBox tbparameter;
		private System.Windows.Forms.Button parameterbutton;
		private System.Windows.Forms.ListBox lbentity;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.GroupBox groupBox6;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.GroupBox groupBox7;
		private System.Windows.Forms.GroupBox groupBox8;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Button button1;
        private Button button2;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public HazopConfigControl()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.profileview = new System.Windows.Forms.ListView();
            this.addprofile = new System.Windows.Forms.Button();
            this.studynodeview = new System.Windows.Forms.ListView();
            this.addstudy = new System.Windows.Forms.Button();
            this.tbprofilename = new System.Windows.Forms.TextBox();
            this.lbdiagramtype = new System.Windows.Forms.ListBox();
            this.parameterview = new System.Windows.Forms.ListView();
            this.guidewordview = new System.Windows.Forms.ListView();
            this.deletebutton = new System.Windows.Forms.Button();
            this.deletestudy = new System.Windows.Forms.Button();
            this.parameterdelete = new System.Windows.Forms.Button();
            this.deleteguide = new System.Windows.Forms.Button();
            this.addguide = new System.Windows.Forms.Button();
            this.tbguidew = new System.Windows.Forms.TextBox();
            this.lbstudynode = new System.Windows.Forms.TextBox();
            this.tbparameter = new System.Windows.Forms.TextBox();
            this.parameterbutton = new System.Windows.Forms.Button();
            this.lbentity = new System.Windows.Forms.ListBox();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.label2 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.groupBox3 = new System.Windows.Forms.GroupBox();
            this.groupBox8 = new System.Windows.Forms.GroupBox();
            this.button1 = new System.Windows.Forms.Button();
            this.label6 = new System.Windows.Forms.Label();
            this.groupBox4 = new System.Windows.Forms.GroupBox();
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.groupBox5 = new System.Windows.Forms.GroupBox();
            this.groupBox6 = new System.Windows.Forms.GroupBox();
            this.label5 = new System.Windows.Forms.Label();
            this.groupBox7 = new System.Windows.Forms.GroupBox();
            this.button2 = new System.Windows.Forms.Button();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.groupBox3.SuspendLayout();
            this.groupBox8.SuspendLayout();
            this.groupBox4.SuspendLayout();
            this.groupBox5.SuspendLayout();
            this.groupBox6.SuspendLayout();
            this.groupBox7.SuspendLayout();
            this.SuspendLayout();
            // 
            // profileview
            // 
            this.profileview.Alignment = System.Windows.Forms.ListViewAlignment.Default;
            this.profileview.Location = new System.Drawing.Point(8, 24);
            this.profileview.Name = "profileview";
            this.profileview.Size = new System.Drawing.Size(216, 112);
            this.profileview.TabIndex = 0;
            this.profileview.UseCompatibleStateImageBehavior = false;
            this.profileview.SelectedIndexChanged += new System.EventHandler(this.profileview_SelectedIndexChanged);
            // 
            // addprofile
            // 
            this.addprofile.Location = new System.Drawing.Point(300, 99);
            this.addprofile.Name = "addprofile";
            this.addprofile.Size = new System.Drawing.Size(80, 24);
            this.addprofile.TabIndex = 1;
            this.addprofile.Text = "Add";
            this.addprofile.Click += new System.EventHandler(this.addprofile_Click);
            // 
            // studynodeview
            // 
            this.studynodeview.Alignment = System.Windows.Forms.ListViewAlignment.Default;
            this.studynodeview.Location = new System.Drawing.Point(8, 16);
            this.studynodeview.Name = "studynodeview";
            this.studynodeview.Size = new System.Drawing.Size(208, 112);
            this.studynodeview.TabIndex = 2;
            this.studynodeview.UseCompatibleStateImageBehavior = false;
            this.studynodeview.SelectedIndexChanged += new System.EventHandler(this.studynodeview_SelectedIndexChanged);
            // 
            // addstudy
            // 
            this.addstudy.Location = new System.Drawing.Point(300, 96);
            this.addstudy.Name = "addstudy";
            this.addstudy.Size = new System.Drawing.Size(72, 24);
            this.addstudy.TabIndex = 3;
            this.addstudy.Text = "Add";
            this.addstudy.Click += new System.EventHandler(this.addstudy_Click);
            // 
            // tbprofilename
            // 
            this.tbprofilename.Location = new System.Drawing.Point(128, 24);
            this.tbprofilename.MaxLength = 254;
            this.tbprofilename.Name = "tbprofilename";
            this.tbprofilename.Size = new System.Drawing.Size(120, 20);
            this.tbprofilename.TabIndex = 4;
            // 
            // lbdiagramtype
            // 
            this.lbdiagramtype.Location = new System.Drawing.Point(128, 56);
            this.lbdiagramtype.Name = "lbdiagramtype";
            this.lbdiagramtype.Size = new System.Drawing.Size(120, 56);
            this.lbdiagramtype.TabIndex = 5;
            this.lbdiagramtype.SelectedIndexChanged += new System.EventHandler(this.lbdiagramtype_SelectedIndexChanged);
            // 
            // parameterview
            // 
            this.parameterview.Alignment = System.Windows.Forms.ListViewAlignment.Default;
            this.parameterview.Location = new System.Drawing.Point(16, 24);
            this.parameterview.Name = "parameterview";
            this.parameterview.Size = new System.Drawing.Size(200, 104);
            this.parameterview.TabIndex = 6;
            this.parameterview.UseCompatibleStateImageBehavior = false;
            this.parameterview.SelectedIndexChanged += new System.EventHandler(this.parameterview_SelectedIndexChanged);
            // 
            // guidewordview
            // 
            this.guidewordview.Alignment = System.Windows.Forms.ListViewAlignment.Default;
            this.guidewordview.Location = new System.Drawing.Point(8, 24);
            this.guidewordview.Name = "guidewordview";
            this.guidewordview.Size = new System.Drawing.Size(200, 112);
            this.guidewordview.TabIndex = 7;
            this.guidewordview.UseCompatibleStateImageBehavior = false;
            this.guidewordview.SelectedIndexChanged += new System.EventHandler(this.guidewordview_SelectedIndexChanged);
            // 
            // deletebutton
            // 
            this.deletebutton.Location = new System.Drawing.Point(230, 117);
            this.deletebutton.Name = "deletebutton";
            this.deletebutton.Size = new System.Drawing.Size(70, 24);
            this.deletebutton.TabIndex = 8;
            this.deletebutton.Text = "Delete";
            this.deletebutton.Click += new System.EventHandler(this.deletebutton_Click);
            // 
            // deletestudy
            // 
            this.deletestudy.Location = new System.Drawing.Point(224, 104);
            this.deletestudy.Name = "deletestudy";
            this.deletestudy.Size = new System.Drawing.Size(70, 24);
            this.deletestudy.TabIndex = 9;
            this.deletestudy.Text = "Delete";
            this.deletestudy.Click += new System.EventHandler(this.deletestudy_Click);
            // 
            // parameterdelete
            // 
            this.parameterdelete.Location = new System.Drawing.Point(222, 104);
            this.parameterdelete.Name = "parameterdelete";
            this.parameterdelete.Size = new System.Drawing.Size(70, 24);
            this.parameterdelete.TabIndex = 10;
            this.parameterdelete.Text = "Delete";
            this.parameterdelete.Click += new System.EventHandler(this.parameterdelete_Click);
            // 
            // deleteguide
            // 
            this.deleteguide.Location = new System.Drawing.Point(224, 112);
            this.deleteguide.Name = "deleteguide";
            this.deleteguide.Size = new System.Drawing.Size(70, 24);
            this.deleteguide.TabIndex = 11;
            this.deleteguide.Text = "Delete";
            this.deleteguide.Click += new System.EventHandler(this.deleteguide_Click);
            // 
            // addguide
            // 
            this.addguide.Location = new System.Drawing.Point(170, 96);
            this.addguide.Name = "addguide";
            this.addguide.Size = new System.Drawing.Size(80, 24);
            this.addguide.TabIndex = 12;
            this.addguide.Text = "Add";
            this.addguide.Click += new System.EventHandler(this.addguide_Click);
            // 
            // tbguidew
            // 
            this.tbguidew.Location = new System.Drawing.Point(152, 40);
            this.tbguidew.MaxLength = 254;
            this.tbguidew.Name = "tbguidew";
            this.tbguidew.Size = new System.Drawing.Size(96, 20);
            this.tbguidew.TabIndex = 13;
            // 
            // lbstudynode
            // 
            this.lbstudynode.Location = new System.Drawing.Point(117, 24);
            this.lbstudynode.MaxLength = 254;
            this.lbstudynode.Name = "lbstudynode";
            this.lbstudynode.Size = new System.Drawing.Size(112, 20);
            this.lbstudynode.TabIndex = 14;
            // 
            // tbparameter
            // 
            this.tbparameter.Location = new System.Drawing.Point(144, 32);
            this.tbparameter.MaxLength = 254;
            this.tbparameter.Name = "tbparameter";
            this.tbparameter.Size = new System.Drawing.Size(100, 20);
            this.tbparameter.TabIndex = 15;
            // 
            // parameterbutton
            // 
            this.parameterbutton.Location = new System.Drawing.Point(300, 86);
            this.parameterbutton.Name = "parameterbutton";
            this.parameterbutton.Size = new System.Drawing.Size(72, 24);
            this.parameterbutton.TabIndex = 16;
            this.parameterbutton.Text = "Add";
            this.parameterbutton.Click += new System.EventHandler(this.parameterbutton_Click);
            // 
            // lbentity
            // 
            this.lbentity.Location = new System.Drawing.Point(112, 56);
            this.lbentity.Name = "lbentity";
            this.lbentity.Size = new System.Drawing.Size(120, 56);
            this.lbentity.TabIndex = 17;
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.groupBox2);
            this.groupBox1.Controls.Add(this.profileview);
            this.groupBox1.Controls.Add(this.deletebutton);
            this.groupBox1.Location = new System.Drawing.Point(8, 0);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(711, 154);
            this.groupBox1.TabIndex = 18;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "HAZOP Transformation Profiles";
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.label2);
            this.groupBox2.Controls.Add(this.tbprofilename);
            this.groupBox2.Controls.Add(this.lbdiagramtype);
            this.groupBox2.Controls.Add(this.addprofile);
            this.groupBox2.Controls.Add(this.label1);
            this.groupBox2.Location = new System.Drawing.Point(306, 18);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(399, 129);
            this.groupBox2.TabIndex = 1;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Add Profile";
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(16, 56);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(96, 24);
            this.label2.TabIndex = 20;
            this.label2.Text = "Diagram type";
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(16, 24);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(48, 24);
            this.label1.TabIndex = 19;
            this.label1.Text = "Name";
            // 
            // groupBox3
            // 
            this.groupBox3.Controls.Add(this.guidewordview);
            this.groupBox3.Controls.Add(this.groupBox8);
            this.groupBox3.Controls.Add(this.deleteguide);
            this.groupBox3.Location = new System.Drawing.Point(8, 469);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Size = new System.Drawing.Size(711, 152);
            this.groupBox3.TabIndex = 19;
            this.groupBox3.TabStop = false;
            this.groupBox3.Text = "Parameter Guide Words";
            // 
            // groupBox8
            // 
            this.groupBox8.Controls.Add(this.button1);
            this.groupBox8.Controls.Add(this.tbguidew);
            this.groupBox8.Controls.Add(this.addguide);
            this.groupBox8.Controls.Add(this.label6);
            this.groupBox8.Location = new System.Drawing.Point(306, 16);
            this.groupBox8.Name = "groupBox8";
            this.groupBox8.Size = new System.Drawing.Size(380, 131);
            this.groupBox8.TabIndex = 0;
            this.groupBox8.TabStop = false;
            this.groupBox8.Text = "Add Guide Word";
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(15, 96);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(88, 24);
            this.button1.TabIndex = 23;
            this.button1.Text = "Add Generics";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // label6
            // 
            this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label6.Location = new System.Drawing.Point(24, 40);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(48, 24);
            this.label6.TabIndex = 22;
            this.label6.Text = "Name";
            // 
            // groupBox4
            // 
            this.groupBox4.BackColor = System.Drawing.SystemColors.ButtonFace;
            this.groupBox4.Controls.Add(this.lbstudynode);
            this.groupBox4.Controls.Add(this.lbentity);
            this.groupBox4.Controls.Add(this.addstudy);
            this.groupBox4.Controls.Add(this.label3);
            this.groupBox4.Controls.Add(this.label4);
            this.groupBox4.Location = new System.Drawing.Point(306, 8);
            this.groupBox4.Name = "groupBox4";
            this.groupBox4.Size = new System.Drawing.Size(380, 127);
            this.groupBox4.TabIndex = 10;
            this.groupBox4.TabStop = false;
            this.groupBox4.Text = "Add Study Nodes";
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(16, 24);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(48, 24);
            this.label3.TabIndex = 21;
            this.label3.Text = "Name";
            // 
            // label4
            // 
            this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(16, 64);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(64, 24);
            this.label4.TabIndex = 21;
            this.label4.Text = "Extends";
            // 
            // groupBox5
            // 
            this.groupBox5.Controls.Add(this.groupBox4);
            this.groupBox5.Controls.Add(this.studynodeview);
            this.groupBox5.Controls.Add(this.deletestudy);
            this.groupBox5.Location = new System.Drawing.Point(8, 160);
            this.groupBox5.Name = "groupBox5";
            this.groupBox5.Size = new System.Drawing.Size(711, 143);
            this.groupBox5.TabIndex = 20;
            this.groupBox5.TabStop = false;
            this.groupBox5.Text = "Diagram Study Nodes";
            // 
            // groupBox6
            // 
            this.groupBox6.Controls.Add(this.tbparameter);
            this.groupBox6.Controls.Add(this.parameterbutton);
            this.groupBox6.Controls.Add(this.label5);
            this.groupBox6.Location = new System.Drawing.Point(306, 18);
            this.groupBox6.Name = "groupBox6";
            this.groupBox6.Size = new System.Drawing.Size(380, 125);
            this.groupBox6.TabIndex = 0;
            this.groupBox6.TabStop = false;
            this.groupBox6.Text = "Add Parameter";
            // 
            // label5
            // 
            this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(16, 32);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(48, 24);
            this.label5.TabIndex = 21;
            this.label5.Text = "Name";
            // 
            // groupBox7
            // 
            this.groupBox7.Controls.Add(this.parameterview);
            this.groupBox7.Controls.Add(this.groupBox6);
            this.groupBox7.Controls.Add(this.parameterdelete);
            this.groupBox7.Location = new System.Drawing.Point(8, 309);
            this.groupBox7.Name = "groupBox7";
            this.groupBox7.Size = new System.Drawing.Size(711, 154);
            this.groupBox7.TabIndex = 21;
            this.groupBox7.TabStop = false;
            this.groupBox7.Text = "Study Node Parameters";
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(631, 627);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(82, 27);
            this.button2.TabIndex = 22;
            this.button2.Text = "BACK";
            this.button2.UseVisualStyleBackColor = true;
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // HazopConfigControl
            // 
            this.BackColor = System.Drawing.SystemColors.Control;
            this.Controls.Add(this.button2);
            this.Controls.Add(this.groupBox7);
            this.Controls.Add(this.groupBox5);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.groupBox3);
            this.Name = "HazopConfigControl";
            this.Size = new System.Drawing.Size(731, 656);
            this.Load += new System.EventHandler(this.HazopConfigControl_Load);
            this.groupBox1.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.groupBox3.ResumeLayout(false);
            this.groupBox8.ResumeLayout(false);
            this.groupBox8.PerformLayout();
            this.groupBox4.ResumeLayout(false);
            this.groupBox4.PerformLayout();
            this.groupBox5.ResumeLayout(false);
            this.groupBox6.ResumeLayout(false);
            this.groupBox6.PerformLayout();
            this.groupBox7.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		private void HazopConfigControl_Load(object sender, System.EventArgs e)
		{
			
			config = new HazopTransformationProfileManager();
			InitializeProfileListView();
			InitializeStudyNodeListView();
			InitializeParameterListView();
			InitializeGuidewordView();
			
			FillProfileListView();
			FillDiagramTypeListBox();
			FillEntityListBox();
			
			
		}

		public void FillParameterListBox(int id)
		{
			parameterdata = config.GetParameters(id);
			parameterview.Items.Clear();

			for(int i=0;i<parameterdata.Rows.Count;i++)
			{
				parameterview.Items.Add(parameterdata.Rows[i][1].ToString());
			}
		}

		public void FillGuideWordsListBox(int id)
		{
			guideworddata = config.GetGuideWords(id);
			guidewordview.Items.Clear();

			for(int i=0;i<guideworddata.Rows.Count;i++)
			{
				guidewordview.Items.Add(guideworddata.Rows[i][1].ToString());
			}

		}


		public void FillEntityListBox()
		{

			lbentity.Items.Clear();
        
			if(profileview.SelectedIndices.Count>0)
			{
				entitydata = config.GetUMLEntityTypes((int)profiledata.Rows[profileview.SelectedItems[0].Index][3]);			
			
				for(int i=0;i<entitydata.Rows.Count;i++)
				{
					lbentity.Items.Add(entitydata.Rows[i][1].ToString());
				}

				if(entitydata.Rows.Count>0)
					lbentity.SelectedIndex=0;

			}
		}

		public void FillDiagramTypeListBox()
		{
			digramtypes = config.GetDiagramTypes();
			lbdiagramtype.Items.Clear();
							
			for(int i=0;i<digramtypes.Rows.Count;i++)
			{
				lbdiagramtype.Items.Add(digramtypes.Rows[i][1].ToString());
			}		

			lbdiagramtype.SelectedIndex=0;

		}

		public void FillProfileListView()
		{
			profileview.Items.Clear();
			profiledata = config.GetProfiles();
						
			for(int i=0;i<profiledata.Rows.Count;i++)
			{				
				profileview.Items.Add(new ListViewItem(new String[]{profiledata.Rows[i][1].ToString(),profiledata.Rows[i][2].ToString()}));
			}

		
		}

		public void FillStudyNodeListView(int id)
		{
			
			studynodeview.Items.Clear();
			studynodedata = config.GetStudyNodes(id);			
			
			for(int i=0;i<studynodedata.Rows.Count;i++)
			{				
				studynodeview.Items.Add(new ListViewItem(new String[]{studynodedata.Rows[i][1].ToString(),studynodedata.Rows[i][2].ToString()}));

			}
		}

		public void InitializeProfileListView()
		{
			
			profileview.View = View.Details;
			profileview.AllowColumnReorder = false;
			profileview.FullRowSelect = true;
			profileview.GridLines = true;
			profileview.Sorting = SortOrder.None;			

			profileview.Columns.Add("Profile", 100, HorizontalAlignment.Left);
			profileview.Columns.Add("DiagramType", 100, HorizontalAlignment.Left);
				

		}

		public void InitializeStudyNodeListView()
		{
			
			studynodeview.View = View.Details;
			//studynodeview.LabelEdit = fa;
			studynodeview.AllowColumnReorder = false;
			studynodeview.FullRowSelect = true;
			studynodeview.GridLines = true;
			studynodeview.Sorting = SortOrder.None;			

			studynodeview.Columns.Add("Study node", 100, HorizontalAlignment.Left);
			studynodeview.Columns.Add("Extends", 100, HorizontalAlignment.Left);
			
						
		

		}

		
		public void InitializeParameterListView()
		{			
			parameterview.View = View.Details;
			//studynodeview.LabelEdit = fa;
			parameterview.AllowColumnReorder = false;
			parameterview.FullRowSelect = true;
			parameterview.GridLines = true;
			parameterview.Sorting = SortOrder.None;			

			parameterview.Columns.Add("Name", 100, HorizontalAlignment.Left);
		}

		public void InitializeGuidewordView()
		{			
			guidewordview.View = View.Details;
			//studynodeview.LabelEdit = fa;
			guidewordview.AllowColumnReorder = false;
			guidewordview.FullRowSelect = true;
			guidewordview.GridLines = true;
			guidewordview.Sorting = SortOrder.None;

			guidewordview.Columns.Add("Name", 100, HorizontalAlignment.Left);
		}









		private void profileview_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(profileview.SelectedItems.Count > 0)
			{
			
				guidewordview.Items.Clear();
				parameterview.Items.Clear();

				selectedprofile = int.Parse(profiledata.Rows[profileview.SelectedItems[0].Index][0].ToString());
				selecteddiagramtype = int.Parse(profiledata.Rows[profileview.SelectedItems[0].Index][3].ToString());
				FillStudyNodeListView(selectedprofile);
				FillEntityListBox();

			}

			
		}

		public void ClearAllViews()
		{
			ClearProfiles();
			ClearStudyNodes();
			ClearParameters();
			ClearGuideWords();		
		}

		public void ClearProfiles(){profileview.Items.Clear();}

		public void ClearStudyNodes(){studynodeview.Items.Clear();}

		public void ClearParameters(){parameterview.Items.Clear();}

		public void ClearGuideWords(){guidewordview.Items.Clear();}


		private void studynodeview_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(studynodeview.SelectedItems.Count > 0)
			{
				
				guidewordview.Items.Clear();
				selectedstudynode = int.Parse(studynodedata.Rows[studynodeview.SelectedItems[0].Index][0].ToString());
				FillParameterListBox(selectedstudynode);
			}
		}

		private void parameterview_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(parameterview.SelectedItems.Count > 0)
			{
				guidewordview.Items.Clear();
				selectedparameter = int.Parse(parameterdata.Rows[parameterview.SelectedItems[0].Index][0].ToString());
				FillGuideWordsListBox(selectedparameter);
			}


		}

		private void guidewordview_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(guidewordview.SelectedItems.Count > 0)
			{
				selectedguideword = int.Parse(guideworddata.Rows[guidewordview.SelectedItems[0].Index][0].ToString());

			}
		}

		private void deletebutton_Click(object sender, System.EventArgs e)
		{
			if(profileview.SelectedItems.Count>0)
			{
				DialogResult dr = new DialogResult();

				dr = MessageBox.Show(this,"Do you want to delete the selected items?","",MessageBoxButtons.YesNo);
				
				if(dr.ToString().Equals("Yes"))
				{
					for(int i=0;i<profileview.SelectedItems.Count;i++)
					{					
						config.RemoveHazopProfile(int.Parse(profiledata.Rows[profileview.SelectedItems[i].Index][0].ToString()));
					}

					ClearAllViews();
					FillProfileListView();
				}
			}
		}

		private void deletestudy_Click(object sender, System.EventArgs e)
		{
			if(studynodeview.SelectedItems.Count>0)
			{
				DialogResult dr = new DialogResult();

				dr = MessageBox.Show(this,"Do you want to delete the selected items?","",MessageBoxButtons.YesNo);
				
				if(dr.ToString().Equals("Yes"))
				{
					for(int i=0;i<studynodeview.SelectedItems.Count;i++)
					{					
						config.RemoveStudyNode(int.Parse(studynodedata.Rows[studynodeview.SelectedItems[i].Index][0].ToString()));
					}

					ClearGuideWords();
					ClearParameters();
					ClearStudyNodes();
					FillStudyNodeListView(selectedprofile);
				}
			}
		}

		private void parameterdelete_Click(object sender, System.EventArgs e)
		{
			if(parameterview.SelectedItems.Count>0)
			{
				DialogResult dr = new DialogResult();

				dr = MessageBox.Show(this,"Do you want to delete the selected items?","",MessageBoxButtons.YesNo);
				
				if(dr.ToString().Equals("Yes"))
				{
					for(int i=0;i<parameterview.SelectedItems.Count;i++)
					{					
						config.RemoveParameter(int.Parse(parameterdata.Rows[parameterview.SelectedItems[i].Index][0].ToString()));
					}

					ClearGuideWords();
					ClearParameters();
					FillParameterListBox(selectedstudynode);
				}
			}
		}

		private void deleteguide_Click(object sender, System.EventArgs e)
		{
			if(guidewordview.SelectedItems.Count>0)
			{
				DialogResult dr = new DialogResult();

				dr = MessageBox.Show(this,"Do you want to delete the selected items?","",MessageBoxButtons.YesNo);
				
				if(dr.ToString().Equals("Yes"))
				{
					for(int i=0;i<guidewordview.SelectedItems.Count;i++)
					{					
						config.RemoveGuideWord(int.Parse(guideworddata.Rows[guidewordview.SelectedItems[i].Index][0].ToString()));
					}

					ClearGuideWords();
					FillGuideWordsListBox(selectedparameter);
				}
			}
		}

		private void addguide_Click(object sender, System.EventArgs e)
		{
			
			if(validator.ValidateTextAlfaNumerical(tbguidew.Text))
			{
				if(parameterview.SelectedItems.Count>0)
				{
					if(tbguidew.Text.Length>0)
						config.AddGuideWord(tbguidew.Text,selectedparameter);

					FillGuideWordsListBox(selectedparameter);
				}
				else
				{
					MessageBox.Show("Please select a parameter first","",MessageBoxButtons.OK);
				}
			}
			else
			{
				MessageBox.Show("The name of the guide word must be in a alphabetical format","",MessageBoxButtons.OK);

			}


		}

		private void addprofile_Click(object sender, System.EventArgs e)
		{	
			
			if(validator.ValidateTextAlfaNumerical(tbprofilename.Text))
			{
			
				if(lbdiagramtype.SelectedIndex!=-1)
					config.AddProfile(tbprofilename.Text,(int)(digramtypes.Rows[lbdiagramtype.SelectedIndex][0]));
				else
					config.AddProfile(tbprofilename.Text,(int)(digramtypes.Rows[0][0]));

				ClearAllViews();
				FillProfileListView();
			}
			else
			{
				MessageBox.Show("The name of the profile must be in a alpha-numerical format","",MessageBoxButtons.OK);

			}
		}

		private void lbdiagramtype_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

		private void addstudy_Click(object sender, System.EventArgs e)
		{

			if(validator.ValidateTextAlfa(lbstudynode.Text))
			{
			
				if(profileview.SelectedItems.Count>0)
				{
					config.AddStudyNode(lbstudynode.Text,selectedprofile,(int)(entitydata.Rows[lbentity.SelectedIndex][0]));
			
					ClearStudyNodes();
					FillStudyNodeListView(selectedprofile);
				
				}
				else
				{
					MessageBox.Show("Please select a profile first","",MessageBoxButtons.OK);
				}
			}
			else
			{
				MessageBox.Show("The name of the studynode must be in a alphabetical format","",MessageBoxButtons.OK);

			}


			//else
				//config.AddProfile(tbprofilename.Text,(int)(digramtypes.Rows[0][0]));

			//ClearAllViews();
			//FillProfileListView();

			//config.AddStudyNode(lbstudynode.Text,selectedprofile,entitydata.Rows[][]);
		}

		private void parameterbutton_Click(object sender, System.EventArgs e)
		{
			if(validator.ValidateTextAlfa(tbparameter.Text))
			{
				if(studynodeview.SelectedItems.Count>0)
				{
					config.AddParameter(tbparameter.Text,selectedstudynode);
					FillParameterListBox(selectedstudynode);

				}
				else
				{
					MessageBox.Show("Please select a studynode first","",MessageBoxButtons.OK);
				}
			}
			else
			{
				MessageBox.Show("The name of the parameter must be in a alphabetical format","",MessageBoxButtons.OK);

			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{

			if(parameterview.SelectedItems.Count>0)
			{

				GenericGuideWordSelector selector = new GenericGuideWordSelector();
				DialogResult dr = new DialogResult();
				dr = selector.ShowDialog();

				if(dr == DialogResult.OK)
				{
					if(selector.cno.Checked)
						config.AddGuideWord("No",selectedparameter);		

					if(selector.cmore.Checked)
						config.AddGuideWord("More",selectedparameter);		

					if(selector.cless.Checked)
						config.AddGuideWord("Less",selectedparameter);		

					if(selector.cawa.Checked)
						config.AddGuideWord("As Well As",selectedparameter);	
	
					if(selector.cbefore.Checked)
						config.AddGuideWord("Before",selectedparameter);	
	
					if(selector.cpartof.Checked)
						config.AddGuideWord("Part Of",selectedparameter);
	
					if(selector.creverse.Checked)
						config.AddGuideWord("Reverse",selectedparameter);


					if(selector.cother.Checked)
						config.AddGuideWord("Other Than",selectedparameter);

					if(selector.cearly.Checked)
						config.AddGuideWord("Early",selectedparameter);

					if(selector.clate.Checked)
						config.AddGuideWord("Late",selectedparameter);

					if(selector.cafter.Checked)
						config.AddGuideWord("After",selectedparameter);

				}
				
				FillGuideWordsListBox(selectedparameter);

			}
			else
			{
				MessageBox.Show("Please select a parameter first","",MessageBoxButtons.OK);
			}
		}

        private void button2_Click(object sender, EventArgs e)
        {
            ((MainForm)(this.Parent)).SetUserControl("Menu");
        }

		
		

		

		

	}
}
