using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace RiskAnalysis
{
	/// <summary>
	/// Summary description for PHAConfigControl.
	/// </summary>
	public class PHAConfigControl : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox tbprofilename;
		private System.Windows.Forms.ListBox lbdiagramtype;
		private System.Windows.Forms.Button addprofile;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ListView profileview;
        private System.Windows.Forms.Button deletebutton;
        //private IContainer components;
		int selectedprofile = -1;
		int selecteddiagramtype = -1;
		int selectedstudynode = -1;

		PHATransformationProfileManager config = new PHATransformationProfileManager();
		
		DataTable profiledata;
		private DataTable digramtypes;
		private DataTable studynodedata;		
		private DataTable entitydata;

		DataTable checklistitems;
        DataTable tagchecklistitems;

		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.TextBox lbstudynode;
		private System.Windows.Forms.ListBox lbentity;
		private System.Windows.Forms.Button addstudy;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.ListView studynodeview;
		private System.Windows.Forms.Button deletestudy;
		private System.Windows.Forms.GroupBox groupBox7;
		private System.Windows.Forms.GroupBox groupBox6;
		private System.Windows.Forms.Button parameterbutton;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Button parameterdelete;
        private System.Windows.Forms.Label label6;
		private System.Windows.Forms.ListView checklistview;
        private System.Windows.Forms.TextBox tbchecklistitem;
        private Label label8;
        private Button button1;
        private TextBox tbtagchecklistitem;
        private TextBox cltagdesc;
        private Label label7;
        private Label label9;
        private TextBox tagname;
        private GroupBox groupBox3;
        private Label label10;
        private TextBox tagvalue;
        private ComboBox tagoperator;
        private ListView tagchecklistview;
        private Button button2;
        private TextBox cldesc;
        private Button button3;

		Validator validator = new Validator();

		public PHAConfigControl()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				/*if(components != null)
				{
					components.Dispose();
				}*/
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.label2 = new System.Windows.Forms.Label();
            this.tbprofilename = new System.Windows.Forms.TextBox();
            this.lbdiagramtype = new System.Windows.Forms.ListBox();
            this.addprofile = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.profileview = new System.Windows.Forms.ListView();
            this.deletebutton = new System.Windows.Forms.Button();
            this.groupBox5 = new System.Windows.Forms.GroupBox();
            this.groupBox4 = new System.Windows.Forms.GroupBox();
            this.lbstudynode = new System.Windows.Forms.TextBox();
            this.lbentity = new System.Windows.Forms.ListBox();
            this.addstudy = new System.Windows.Forms.Button();
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.studynodeview = new System.Windows.Forms.ListView();
            this.deletestudy = new System.Windows.Forms.Button();
            this.groupBox7 = new System.Windows.Forms.GroupBox();
            this.groupBox3 = new System.Windows.Forms.GroupBox();
            this.label10 = new System.Windows.Forms.Label();
            this.tagvalue = new System.Windows.Forms.TextBox();
            this.tagoperator = new System.Windows.Forms.ComboBox();
            this.tagname = new System.Windows.Forms.TextBox();
            this.label9 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.cltagdesc = new System.Windows.Forms.TextBox();
            this.tbtagchecklistitem = new System.Windows.Forms.TextBox();
            this.button1 = new System.Windows.Forms.Button();
            this.label8 = new System.Windows.Forms.Label();
            this.tagchecklistview = new System.Windows.Forms.ListView();
            this.button2 = new System.Windows.Forms.Button();
            this.checklistview = new System.Windows.Forms.ListView();
            this.groupBox6 = new System.Windows.Forms.GroupBox();
            this.label6 = new System.Windows.Forms.Label();
            this.cldesc = new System.Windows.Forms.TextBox();
            this.tbchecklistitem = new System.Windows.Forms.TextBox();
            this.parameterbutton = new System.Windows.Forms.Button();
            this.label5 = new System.Windows.Forms.Label();
            this.parameterdelete = new System.Windows.Forms.Button();
            this.button3 = new System.Windows.Forms.Button();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.groupBox5.SuspendLayout();
            this.groupBox4.SuspendLayout();
            this.groupBox7.SuspendLayout();
            this.groupBox3.SuspendLayout();
            this.groupBox6.SuspendLayout();
            this.SuspendLayout();
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.groupBox2);
            this.groupBox1.Controls.Add(this.profileview);
            this.groupBox1.Controls.Add(this.deletebutton);
            this.groupBox1.Location = new System.Drawing.Point(0, 3);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(666, 136);
            this.groupBox1.TabIndex = 19;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "PHA Profiles";
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.label2);
            this.groupBox2.Controls.Add(this.tbprofilename);
            this.groupBox2.Controls.Add(this.lbdiagramtype);
            this.groupBox2.Controls.Add(this.addprofile);
            this.groupBox2.Controls.Add(this.label1);
            this.groupBox2.Location = new System.Drawing.Point(322, 16);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(338, 112);
            this.groupBox2.TabIndex = 1;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Add Profile";
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(16, 40);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(96, 24);
            this.label2.TabIndex = 20;
            this.label2.Text = "Diagram type";
            // 
            // tbprofilename
            // 
            this.tbprofilename.Location = new System.Drawing.Point(128, 15);
            this.tbprofilename.MaxLength = 254;
            this.tbprofilename.Name = "tbprofilename";
            this.tbprofilename.Size = new System.Drawing.Size(120, 20);
            this.tbprofilename.TabIndex = 4;
            // 
            // lbdiagramtype
            // 
            this.lbdiagramtype.Location = new System.Drawing.Point(128, 41);
            this.lbdiagramtype.Name = "lbdiagramtype";
            this.lbdiagramtype.Size = new System.Drawing.Size(120, 56);
            this.lbdiagramtype.TabIndex = 5;
            // 
            // addprofile
            // 
            this.addprofile.Location = new System.Drawing.Point(252, 73);
            this.addprofile.Name = "addprofile";
            this.addprofile.Size = new System.Drawing.Size(80, 24);
            this.addprofile.TabIndex = 1;
            this.addprofile.Text = "Add";
            this.addprofile.Click += new System.EventHandler(this.addprofile_Click);
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(16, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(48, 24);
            this.label1.TabIndex = 19;
            this.label1.Text = "Name";
            // 
            // profileview
            // 
            this.profileview.Alignment = System.Windows.Forms.ListViewAlignment.Default;
            this.profileview.Location = new System.Drawing.Point(6, 16);
            this.profileview.Name = "profileview";
            this.profileview.Size = new System.Drawing.Size(216, 112);
            this.profileview.TabIndex = 0;
            this.profileview.UseCompatibleStateImageBehavior = false;
            this.profileview.SelectedIndexChanged += new System.EventHandler(this.profileview_SelectedIndexChanged);
            // 
            // deletebutton
            // 
            this.deletebutton.Location = new System.Drawing.Point(231, 104);
            this.deletebutton.Name = "deletebutton";
            this.deletebutton.Size = new System.Drawing.Size(70, 24);
            this.deletebutton.TabIndex = 8;
            this.deletebutton.Text = "Delete";
            this.deletebutton.Click += new System.EventHandler(this.deletebutton_Click);
            // 
            // groupBox5
            // 
            this.groupBox5.Controls.Add(this.groupBox4);
            this.groupBox5.Controls.Add(this.studynodeview);
            this.groupBox5.Controls.Add(this.deletestudy);
            this.groupBox5.Location = new System.Drawing.Point(0, 145);
            this.groupBox5.Name = "groupBox5";
            this.groupBox5.Size = new System.Drawing.Size(666, 140);
            this.groupBox5.TabIndex = 21;
            this.groupBox5.TabStop = false;
            this.groupBox5.Text = "Study Nodes";
            // 
            // groupBox4
            // 
            this.groupBox4.Controls.Add(this.lbstudynode);
            this.groupBox4.Controls.Add(this.lbentity);
            this.groupBox4.Controls.Add(this.addstudy);
            this.groupBox4.Controls.Add(this.label3);
            this.groupBox4.Controls.Add(this.label4);
            this.groupBox4.Location = new System.Drawing.Point(322, 8);
            this.groupBox4.Name = "groupBox4";
            this.groupBox4.Size = new System.Drawing.Size(338, 122);
            this.groupBox4.TabIndex = 10;
            this.groupBox4.TabStop = false;
            this.groupBox4.Text = "Add Study Node";
            // 
            // lbstudynode
            // 
            this.lbstudynode.Location = new System.Drawing.Point(128, 14);
            this.lbstudynode.MaxLength = 254;
            this.lbstudynode.Name = "lbstudynode";
            this.lbstudynode.Size = new System.Drawing.Size(112, 20);
            this.lbstudynode.TabIndex = 14;
            // 
            // lbentity
            // 
            this.lbentity.Location = new System.Drawing.Point(120, 45);
            this.lbentity.Name = "lbentity";
            this.lbentity.Size = new System.Drawing.Size(120, 56);
            this.lbentity.TabIndex = 17;
            // 
            // addstudy
            // 
            this.addstudy.Location = new System.Drawing.Point(252, 77);
            this.addstudy.Name = "addstudy";
            this.addstudy.Size = new System.Drawing.Size(80, 24);
            this.addstudy.TabIndex = 3;
            this.addstudy.Text = "Add";
            this.addstudy.Click += new System.EventHandler(this.addstudy_Click);
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(16, 15);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(48, 24);
            this.label3.TabIndex = 21;
            this.label3.Text = "Name";
            // 
            // label4
            // 
            this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(16, 45);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(64, 24);
            this.label4.TabIndex = 21;
            this.label4.Text = "Extends";
            // 
            // studynodeview
            // 
            this.studynodeview.Alignment = System.Windows.Forms.ListViewAlignment.Default;
            this.studynodeview.Location = new System.Drawing.Point(6, 18);
            this.studynodeview.Name = "studynodeview";
            this.studynodeview.Size = new System.Drawing.Size(208, 112);
            this.studynodeview.TabIndex = 2;
            this.studynodeview.UseCompatibleStateImageBehavior = false;
            this.studynodeview.SelectedIndexChanged += new System.EventHandler(this.studynodeview_SelectedIndexChanged);
            // 
            // deletestudy
            // 
            this.deletestudy.Location = new System.Drawing.Point(231, 106);
            this.deletestudy.Name = "deletestudy";
            this.deletestudy.Size = new System.Drawing.Size(70, 24);
            this.deletestudy.TabIndex = 9;
            this.deletestudy.Text = "Delete";
            this.deletestudy.Click += new System.EventHandler(this.deletestudy_Click);
            // 
            // groupBox7
            // 
            this.groupBox7.Controls.Add(this.groupBox3);
            this.groupBox7.Controls.Add(this.tagchecklistview);
            this.groupBox7.Controls.Add(this.button2);
            this.groupBox7.Controls.Add(this.checklistview);
            this.groupBox7.Controls.Add(this.groupBox6);
            this.groupBox7.Controls.Add(this.parameterdelete);
            this.groupBox7.Location = new System.Drawing.Point(3, 291);
            this.groupBox7.Name = "groupBox7";
            this.groupBox7.Size = new System.Drawing.Size(663, 433);
            this.groupBox7.TabIndex = 22;
            this.groupBox7.TabStop = false;
            this.groupBox7.Text = "Check List Items";
            // 
            // groupBox3
            // 
            this.groupBox3.Controls.Add(this.label10);
            this.groupBox3.Controls.Add(this.tagvalue);
            this.groupBox3.Controls.Add(this.tagoperator);
            this.groupBox3.Controls.Add(this.tagname);
            this.groupBox3.Controls.Add(this.label9);
            this.groupBox3.Controls.Add(this.label7);
            this.groupBox3.Controls.Add(this.cltagdesc);
            this.groupBox3.Controls.Add(this.tbtagchecklistitem);
            this.groupBox3.Controls.Add(this.button1);
            this.groupBox3.Controls.Add(this.label8);
            this.groupBox3.Location = new System.Drawing.Point(319, 145);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Size = new System.Drawing.Size(338, 216);
            this.groupBox3.TabIndex = 23;
            this.groupBox3.TabStop = false;
            this.groupBox3.Text = "Add Tag Dependent Check List Item";
            // 
            // label10
            // 
            this.label10.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label10.Location = new System.Drawing.Point(7, 74);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(48, 24);
            this.label10.TabIndex = 33;
            this.label10.Text = "Value";
            // 
            // tagvalue
            // 
            this.tagvalue.Location = new System.Drawing.Point(98, 78);
            this.tagvalue.MaxLength = 254;
            this.tagvalue.Name = "tagvalue";
            this.tagvalue.Size = new System.Drawing.Size(144, 20);
            this.tagvalue.TabIndex = 32;
            // 
            // tagoperator
            // 
            this.tagoperator.FormattingEnabled = true;
            this.tagoperator.Location = new System.Drawing.Point(98, 51);
            this.tagoperator.Name = "tagoperator";
            this.tagoperator.Size = new System.Drawing.Size(142, 21);
            this.tagoperator.TabIndex = 31;
            // 
            // tagname
            // 
            this.tagname.Location = new System.Drawing.Point(98, 28);
            this.tagname.MaxLength = 254;
            this.tagname.Name = "tagname";
            this.tagname.Size = new System.Drawing.Size(144, 20);
            this.tagname.TabIndex = 29;
            // 
            // label9
            // 
            this.label9.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label9.Location = new System.Drawing.Point(7, 29);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(48, 24);
            this.label9.TabIndex = 30;
            this.label9.Text = "Tag";
            // 
            // label7
            // 
            this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label7.Location = new System.Drawing.Point(7, 136);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(85, 24);
            this.label7.TabIndex = 28;
            this.label7.Text = "Description";
            // 
            // cltagdesc
            // 
            this.cltagdesc.Location = new System.Drawing.Point(98, 129);
            this.cltagdesc.MaxLength = 254;
            this.cltagdesc.Multiline = true;
            this.cltagdesc.Name = "cltagdesc";
            this.cltagdesc.Size = new System.Drawing.Size(152, 81);
            this.cltagdesc.TabIndex = 27;
            // 
            // tbtagchecklistitem
            // 
            this.tbtagchecklistitem.Location = new System.Drawing.Point(98, 103);
            this.tbtagchecklistitem.MaxLength = 254;
            this.tbtagchecklistitem.Name = "tbtagchecklistitem";
            this.tbtagchecklistitem.Size = new System.Drawing.Size(144, 20);
            this.tbtagchecklistitem.TabIndex = 24;
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(256, 186);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(72, 24);
            this.button1.TabIndex = 25;
            this.button1.Text = "Add";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // label8
            // 
            this.label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label8.Location = new System.Drawing.Point(7, 104);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(48, 24);
            this.label8.TabIndex = 26;
            this.label8.Text = "Name";
            // 
            // tagchecklistview
            // 
            this.tagchecklistview.Alignment = System.Windows.Forms.ListViewAlignment.Default;
            this.tagchecklistview.Location = new System.Drawing.Point(16, 145);
            this.tagchecklistview.Name = "tagchecklistview";
            this.tagchecklistview.Size = new System.Drawing.Size(200, 190);
            this.tagchecklistview.TabIndex = 11;
            this.tagchecklistview.UseCompatibleStateImageBehavior = false;
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(228, 311);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(70, 24);
            this.button2.TabIndex = 12;
            this.button2.Text = "Delete";
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // checklistview
            // 
            this.checklistview.Alignment = System.Windows.Forms.ListViewAlignment.Default;
            this.checklistview.Location = new System.Drawing.Point(16, 24);
            this.checklistview.Name = "checklistview";
            this.checklistview.Size = new System.Drawing.Size(200, 106);
            this.checklistview.TabIndex = 6;
            this.checklistview.UseCompatibleStateImageBehavior = false;
            // 
            // groupBox6
            // 
            this.groupBox6.Controls.Add(this.label6);
            this.groupBox6.Controls.Add(this.cldesc);
            this.groupBox6.Controls.Add(this.tbchecklistitem);
            this.groupBox6.Controls.Add(this.parameterbutton);
            this.groupBox6.Controls.Add(this.label5);
            this.groupBox6.Location = new System.Drawing.Point(319, 16);
            this.groupBox6.Name = "groupBox6";
            this.groupBox6.Size = new System.Drawing.Size(338, 123);
            this.groupBox6.TabIndex = 0;
            this.groupBox6.TabStop = false;
            this.groupBox6.Text = "Add Stereotype Dependant Check List Item";
            // 
            // label6
            // 
            this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label6.Location = new System.Drawing.Point(10, 40);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(82, 24);
            this.label6.TabIndex = 23;
            this.label6.Text = "Description";
            // 
            // cldesc
            // 
            this.cldesc.Location = new System.Drawing.Point(96, 46);
            this.cldesc.MaxLength = 254;
            this.cldesc.Multiline = true;
            this.cldesc.Name = "cldesc";
            this.cldesc.Size = new System.Drawing.Size(152, 68);
            this.cldesc.TabIndex = 22;
            // 
            // tbchecklistitem
            // 
            this.tbchecklistitem.Location = new System.Drawing.Point(98, 20);
            this.tbchecklistitem.MaxLength = 254;
            this.tbchecklistitem.Name = "tbchecklistitem";
            this.tbchecklistitem.Size = new System.Drawing.Size(144, 20);
            this.tbchecklistitem.TabIndex = 15;
            // 
            // parameterbutton
            // 
            this.parameterbutton.Location = new System.Drawing.Point(260, 90);
            this.parameterbutton.Name = "parameterbutton";
            this.parameterbutton.Size = new System.Drawing.Size(72, 24);
            this.parameterbutton.TabIndex = 16;
            this.parameterbutton.Text = "Add";
            this.parameterbutton.Click += new System.EventHandler(this.parameterbutton_Click);
            // 
            // label5
            // 
            this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(10, 16);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(48, 24);
            this.label5.TabIndex = 21;
            this.label5.Text = "Name";
            // 
            // parameterdelete
            // 
            this.parameterdelete.Location = new System.Drawing.Point(228, 106);
            this.parameterdelete.Name = "parameterdelete";
            this.parameterdelete.Size = new System.Drawing.Size(70, 24);
            this.parameterdelete.TabIndex = 10;
            this.parameterdelete.Text = "Delete";
            this.parameterdelete.Click += new System.EventHandler(this.parameterdelete_Click);
            // 
            // button3
            // 
            this.button3.Location = new System.Drawing.Point(672, 622);
            this.button3.Name = "button3";
            this.button3.Size = new System.Drawing.Size(60, 24);
            this.button3.TabIndex = 23;
            this.button3.Text = "BACK";
            this.button3.UseVisualStyleBackColor = true;
            this.button3.Click += new System.EventHandler(this.button3_Click);
            // 
            // PHAConfigControl
            // 
            this.Controls.Add(this.button3);
            this.Controls.Add(this.groupBox7);
            this.Controls.Add(this.groupBox5);
            this.Controls.Add(this.groupBox1);
            this.Name = "PHAConfigControl";
            this.Size = new System.Drawing.Size(737, 658);
            this.Load += new System.EventHandler(this.PHAConfigControl_Load);
            this.groupBox1.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.groupBox5.ResumeLayout(false);
            this.groupBox4.ResumeLayout(false);
            this.groupBox4.PerformLayout();
            this.groupBox7.ResumeLayout(false);
            this.groupBox3.ResumeLayout(false);
            this.groupBox3.PerformLayout();
            this.groupBox6.ResumeLayout(false);
            this.groupBox6.PerformLayout();
            this.ResumeLayout(false);

		}
		#endregion

		private void PHAConfigControl_Load(object sender, System.EventArgs e)
		{
			config = new PHATransformationProfileManager();

            tagoperator.Items.Add("=");
            tagoperator.Items.Add("<");
            tagoperator.Items.Add(">");
            tagoperator.Items.Add("!=");
            tagoperator.SelectedIndex = 0;
            
            InitializeProfileListView();			
			FillProfileListView();
			InitializeStudyNodeListView();
			InitCheckListItemView();

			FillDiagramTypeListBox();
            InitTagCheckListItemView();
			FillEntityListBox();	
		}

		public void InitCheckListItemView()
		{	
				checklistview.View = View.Details;
				//studynodeview.LabelEdit = fa;
				checklistview.AllowColumnReorder = false;
				checklistview.FullRowSelect = true;
				checklistview.GridLines = true;
				checklistview.Sorting = SortOrder.None;			

				checklistview.Columns.Add("Name", 100, HorizontalAlignment.Left);
				checklistview.Columns.Add("Description", 100, HorizontalAlignment.Left);
		}

        public void InitTagCheckListItemView()
        {
            tagchecklistview.View = View.Details;
            //studynodeview.LabelEdit = fa;
            tagchecklistview.AllowColumnReorder = false;
            tagchecklistview.FullRowSelect = true;
            tagchecklistview.GridLines = true;
            tagchecklistview.Sorting = SortOrder.None;

            tagchecklistview.Columns.Add("Tag", 100, HorizontalAlignment.Left);
            tagchecklistview.Columns.Add("Name", 100, HorizontalAlignment.Left);
            tagchecklistview.Columns.Add("Description", 100, HorizontalAlignment.Left);
        }



		public void FillStudyNodeListView(int id)
		{
			
			studynodeview.Items.Clear();
			studynodedata = config.GetStudyNodes(id);			
			
			for(int i=0;i<studynodedata.Rows.Count;i++)
			{				

				studynodeview.Items.Add(new ListViewItem(new String[]{studynodedata.Rows[i][1].ToString(),studynodedata.Rows[i][2].ToString()}));

			}
		}

		public void FillEntityListBox()
		{
			lbentity.Items.Clear();
        
			if(profileview.SelectedIndices.Count>0)
			{
				entitydata = config.GetUMLEntityTypes((int)profiledata.Rows[profileview.SelectedItems[0].Index][3]);			
			
				for(int i=0;i<entitydata.Rows.Count;i++)
				{
					lbentity.Items.Add(entitydata.Rows[i][1].ToString());
				}

				if(entitydata.Rows.Count>0)
					lbentity.SelectedIndex=0;
			}
		}



		public void FillDiagramTypeListBox()
		{
			digramtypes = config.GetDiagramTypes();
			lbdiagramtype.Items.Clear();
							
			for(int i=0;i<digramtypes.Rows.Count;i++)
			{
				lbdiagramtype.Items.Add(digramtypes.Rows[i][1].ToString());
			}		

			lbdiagramtype.SelectedIndex=0;
		}

		public void FillProfileListView()
		{
			profileview.Items.Clear();
			profiledata = config.GetProfiles();
						
			for(int i=0;i<profiledata.Rows.Count;i++)
			{				
				profileview.Items.Add(new ListViewItem(new String[]{profiledata.Rows[i][1].ToString(),profiledata.Rows[i][2].ToString()}));
			}
		}

		public void InitializeProfileListView()
		{			
			profileview.View = View.Details;
			profileview.AllowColumnReorder = false;
			profileview.FullRowSelect = true;
			profileview.GridLines = true;
			profileview.Sorting = SortOrder.None;			

			profileview.Columns.Add("Profile", 100, HorizontalAlignment.Left);
			profileview.Columns.Add("DiagramType", 100, HorizontalAlignment.Left);
		}

		public void ClearAllViews()
		{
			ClearProfiles();
			ClearStudyNodes();
		}
        		
		public void ClearProfiles(){profileview.Items.Clear();}
        
		private void addprofile_Click(object sender, System.EventArgs e)
		{
			if(validator.ValidateTextAlfaNumerical(tbprofilename.Text))
			{			
				if(lbdiagramtype.SelectedIndex!=-1)
					config.AddProfile(tbprofilename.Text,(int)(digramtypes.Rows[lbdiagramtype.SelectedIndex][0]));
				else
					config.AddProfile(tbprofilename.Text,(int)(digramtypes.Rows[0][0]));

				ClearAllViews();
				FillProfileListView();
			}
			else
			{
				MessageBox.Show("The name of the profile must be in a alpha-numerical format","",MessageBoxButtons.OK);
			}
		}

		public void InitializeStudyNodeListView()
		{
			
			studynodeview.View = View.Details;
			//studynodeview.LabelEdit = fa;
			studynodeview.AllowColumnReorder = false;
			studynodeview.FullRowSelect = true;
			studynodeview.GridLines = true;
			studynodeview.Sorting = SortOrder.None;
			studynodeview.Columns.Add("Study node", 100, HorizontalAlignment.Left);
			studynodeview.Columns.Add("Extends", 100, HorizontalAlignment.Left);
		}


		private void deletebutton_Click(object sender, System.EventArgs e)
		{
			if(profileview.SelectedItems.Count>0)
			{
				DialogResult dr = new DialogResult();

				dr = MessageBox.Show(this,"Do you want to delete the selected items?","",MessageBoxButtons.YesNo);
				
				if(dr.ToString().Equals("Yes"))
				{
					for(int i=0;i<profileview.SelectedItems.Count;i++)
					{					
						config.RemoveProfile(int.Parse(profiledata.Rows[profileview.SelectedItems[i].Index][0].ToString()));
					}

					ClearAllViews();
					FillProfileListView();
				}
			}
		}



		public void ClearStudyNodes(){studynodeview.Items.Clear();}

		private void addstudy_Click(object sender, System.EventArgs e)
		{
			if(validator.ValidateTextAlfaNumerical(lbstudynode.Text))
			{
			
				if(profileview.SelectedItems.Count>0)
				{
					config.AddStudyNode(lbstudynode.Text,selectedprofile,(int)(entitydata.Rows[lbentity.SelectedIndex][0]));
			
					ClearStudyNodes();
					FillStudyNodeListView(selectedprofile);
				
				}
				else
				{
					MessageBox.Show("Please select a profile first","",MessageBoxButtons.OK);
				}
			}
			else
			{
				MessageBox.Show("The name of the studynode must be in a alphanumerical format","",MessageBoxButtons.OK);

			}

		}

		private void profileview_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(profileview.SelectedItems.Count > 0)
			{
			
				//guidewordview.Items.Clear();
				//parameterview.Items.Clear();

				selectedprofile = int.Parse(profiledata.Rows[profileview.SelectedItems[0].Index][0].ToString());
				selecteddiagramtype = int.Parse(profiledata.Rows[profileview.SelectedItems[0].Index][3].ToString());
				FillStudyNodeListView(selectedprofile);
				FillEntityListBox();

			}
		}

		private void deletestudy_Click(object sender, System.EventArgs e)
		{
			if(studynodeview.SelectedItems.Count>0)
			{
				DialogResult dr = new DialogResult();

				dr = MessageBox.Show(this,"Do you want to delete the selected items?","",MessageBoxButtons.YesNo);
				
				if(dr.ToString().Equals("Yes"))
				{
					for(int i=0;i<studynodeview.SelectedItems.Count;i++)
					{					
						config.RemoveStudyNode(int.Parse(studynodedata.Rows[studynodeview.SelectedItems[i].Index][0].ToString()));
					}

					
					ClearCheckListItems();
					ClearStudyNodes();
					
					checklistview.Items.Clear();
					FillStudyNodeListView(selectedprofile);
				}
			}
		}

		public void FillCheckListItemsListBox(int id)
		{
			checklistitems = config.GetCheckListItems(id);
			checklistview.Items.Clear();

			for(int i=0;i<checklistitems.Rows.Count;i++)
			{
				checklistview.Items.Add(new ListViewItem(new String[]{checklistitems.Rows[i][1].ToString(),checklistitems.Rows[i][2].ToString()}));
			}

		}


        public void FillTagCheckListItemsListBox(int id)
        {
            tagchecklistview.Items.Clear();
            tagchecklistitems = config.GetTagCheckListItems(id);        

            if (tagchecklistitems != null)
            {
                for (int i = 0; i < tagchecklistitems.Rows.Count; i++)
                {
                    //ID, Name, ListItemText, TagName, TagValue, Operator
                    tagchecklistview.Items.Add(new ListViewItem(new String[] { tagchecklistitems.Rows[i][3].ToString() + tagchecklistitems.Rows[i][5].ToString() + tagchecklistitems.Rows[i][4].ToString(), tagchecklistitems.Rows[i][1].ToString(), tagchecklistitems.Rows[i][2].ToString() }));
                }
            }

        }




		private void studynodeview_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(studynodeview.SelectedItems.Count > 0)
			{				
				checklistview.Items.Clear();
				selectedstudynode = int.Parse(studynodedata.Rows[studynodeview.SelectedItems[0].Index][0].ToString());
				FillCheckListItemsListBox(selectedstudynode);
                FillTagCheckListItemsListBox(selectedstudynode);
			}
		}

		public void ClearCheckListItems(){checklistitems.Clear();}

        public void ClearTagCheckListItems() {tagchecklistitems.Clear(); }




		private void parameterdelete_Click(object sender, System.EventArgs e)
		{
			if(checklistview.SelectedItems.Count>0)
			{
				DialogResult dr = new DialogResult();

				dr = MessageBox.Show(this,"Do you want to delete the selected items?","",MessageBoxButtons.YesNo);
				
				if(dr.ToString().Equals("Yes"))
				{
					for(int i=0;i<checklistview.SelectedItems.Count;i++)
					{					
						config.RemoveCheckListItem(int.Parse(checklistitems.Rows[checklistview.SelectedItems[i].Index][0].ToString()));
					}

					//ClearGuideWords();
					ClearCheckListItems();
					FillCheckListItemsListBox(selectedstudynode);
				}
			}
		}

		private void parameterbutton_Click(object sender, System.EventArgs e)
		{ 			
			if(validator.ValidateTextAlfaNumPunctunation(cldesc.Text))
			{
				if(validator.ValidateTextAlfa(tbchecklistitem.Text))
				{
					if(studynodeview.SelectedItems.Count>0)
					{
						config.AddCheckListItem(tbchecklistitem.Text,cldesc.Text,selectedstudynode);
						FillCheckListItemsListBox(selectedstudynode);
					}
					else
					{
						MessageBox.Show("Please select a studynode first","",MessageBoxButtons.OK);
					}
				}
				else
				{
					MessageBox.Show("The name of the checklist item must be in a alphabetical format","",MessageBoxButtons.OK);

				}
			}
			else
			{
				MessageBox.Show("The description must be in a alfanumerical format","",MessageBoxButtons.OK);

			}
		}

    
        private void button1_Click(object sender, EventArgs e)
        {
            if (validator.ValidateTextAlfaNumPunctunation(tagname.Text) && validator.ValidateTextAlfaNumPunctunation(tagvalue.Text))
            {
                if (tagname.Text.Length > 0 || tagvalue.Text.Length > 0)
                {

                    if (validator.ValidateTextAlfaNumPunctunation(cltagdesc.Text))
                    {
                        if (validator.ValidateTextAlfa(tbtagchecklistitem.Text))
                        {
                            if (studynodeview.SelectedItems.Count > 0)
                            {
                                config.AddTagCheckListItem(tbtagchecklistitem.Text, selectedstudynode, cltagdesc.Text, tagname.Text, tagoperator.Text, tagvalue.Text);
                                FillTagCheckListItemsListBox(selectedstudynode);
                            }
                            else
                            {
                                MessageBox.Show("Please select a studynode first", "", MessageBoxButtons.OK);
                            }
                        }
                        else
                        {
                            MessageBox.Show("The name of the checklist item must be in a alphabetical format", "", MessageBoxButtons.OK);
                        }
                    }
                    else
                    {
                        MessageBox.Show("The description must be in a alfanumerical format", "", MessageBoxButtons.OK);
                    }
                }
                else
                {                
                    MessageBox.Show("The tagname and tagvalue must be filled out", "", MessageBoxButtons.OK);
                }
            }           
            else
            {
                MessageBox.Show("The tagname and tagvalue must be in a alfanumerical format", "", MessageBoxButtons.OK);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (tagchecklistview.SelectedItems.Count > 0)
            {
                DialogResult dr = new DialogResult();

                dr = MessageBox.Show(this, "Do you want to delete the selected items?", "", MessageBoxButtons.YesNo);

                if (dr.ToString().Equals("Yes"))
                {
                    for (int i = 0; i < tagchecklistview.SelectedItems.Count; i++)
                    {
                        config.RemoveTagCheckListItem(int.Parse(tagchecklistitems.Rows[tagchecklistview.SelectedItems[i].Index][0].ToString()));
                    }

                    ClearTagCheckListItems();
                    FillTagCheckListItemsListBox(selectedstudynode);
                }
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            ((MainForm)(this.Parent)).SetUserControl("Menu");
        }

       


       

     

	

		
	}
}
