using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace RiskAnalysis
{
    public partial class RiskManagerGUI : UserControl
    {
        public RiskManager rm;
        ArrayList risks = new ArrayList();

        public RiskManagerGUI()
        {
            InitializeComponent();
            rm = new RiskManager();

            ColumnHeader ch;

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Name";
            riskview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Description";
            riskview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Consequence";
            riskview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Likeliehood";
            riskview.Columns.Add(ch);

            riskview.View = View.Details;
         

        }

        private void RiskManagerGUI_Load(object sender, EventArgs e)
        {
            risks = rm.GetRisks();
            DisplayRisks();
        }

        public void DisplayRisks()
        {
            riskview.Items.Clear();

            foreach (Risk risk in risks)
            {
                riskview.Items.Add(new ListViewItem(new string[]{risk.name,risk.description,risk.consequence.ToString(),risk.likeliehood.ToString()}));
            }
        }

        private void Delete_Click(object sender, EventArgs e)
        {
            if (riskview.SelectedItems.Count > 0)
            {
                foreach (ListViewItem item in riskview.SelectedItems)
                {
                    rm.RemoveRisk((Risk)(risks[item.Index]));                    
                }

                DisplayRisks();
            }



        }

        private void add_Click(object sender, EventArgs e)
        {

            AddRiskDialogue ard = new AddRiskDialogue(this);
            ard.ShowDialog();
        }

        private void back_Click(object sender, EventArgs e)
        {
            ((MainForm)(this.Parent)).SetUserControl("Menu");
        }

        private void export_Click(object sender, EventArgs e)
        {
            RiskAnalysis.ReportMaker rm = new ReportMaker();
            saveFileDialog1.ShowDialog();

            if (saveFileDialog1.FileName.Length > 0)
            {
                rm.AppendLine("Risks");
                rm.AppendBreak();
                DataTable datatab = new DataTable();

                datatab.Columns.Add("Name");
                datatab.Columns.Add("Description");
                datatab.Columns.Add("Consequence");
                datatab.Columns.Add("Likeliehood");

                foreach (Risk risk in risks)
                {
                    datatab.Rows.Add(new string[] { risk.name, risk.description, risk.consequence.ToString(), risk.likeliehood.ToString()});
                }

                rm.AppendDataTable(datatab);
                rm.SaveReport(saveFileDialog1.FileName);
            }           
        }

      
    }
}
