using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using EnterpriseRepresentation;

namespace EnterpriseAnalysis
{
    public partial class AnalysisPresenter : UserControl
    {
        EnterpriseRepresentation.EnterpriseRepresentation entrep;
        EnterpriseAnalyzer analyzer = new EnterpriseAnalyzer();
        AnalysisResult result;

        EnterpriseRepresentationCreator prev;

        public AnalysisPresenter(EnterpriseRepresentation.EnterpriseRepresentation entrep, EnterpriseRepresentationCreator prev)
        {
            InitializeComponent();
            this.prev = prev;
            this.entrep = entrep;
            result = analyzer.Analyze(entrep);

            ColumnHeader ch;

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Name";            
            componentview.Columns.Add(ch);
            
            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Criticality";
            componentview.Columns.Add(ch);    
           
            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Availibility";
            componentview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 150;
            ch.Text = "Expected Downtime";
            componentview.Columns.Add(ch);


            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Base Availibility";
            componentview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Importance";
            componentview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Name";
            systemview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Criticality";
            systemview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Availibility";
            systemview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 150;
            ch.Text = "Expected Downtime";
            systemview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Base Availibility";
            systemview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Name";
            environmentview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Criticality";
            environmentview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Availibility";
            environmentview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 150;
            ch.Text = "Expected Downtime";
            environmentview.Columns.Add(ch);


            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Base Availibility";
            environmentview.Columns.Add(ch);


            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Name";
            processview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Criticality";
            processview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Availibility";
            processview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 100;
            ch.Text = "Critical Availibility";
            processview.Columns.Add(ch);

            ch = new ColumnHeader();
            ch.Width = 200;
            ch.Text = "Expected Critial Downtime";
            processview.Columns.Add(ch);


           
            systemview.View = View.Details;
            componentview.View = View.Details;
            environmentview.View = View.Details;
            processview.View = View.Details;

        }

        private void CriticalityPresenter_Load(object sender, EventArgs e)
        {
            ((MainMenu)(this.Parent)).Text = "Analysis Results";

            ComponentAnalyzer compcrit = new ComponentAnalyzer();
         
            foreach (ComponentAnalysisResult res in result.components)
            {
                ListViewItem item = new ListViewItem(new string[] { GetFullNamepath(res.comp), res.criticality.ToString(), res.availibility.ToString(), GetAvailibility(res.availibility), res.baseavailibility.ToString(),res.importance.ToString() });
                componentview.Items.Add(item);
            }

            foreach (SystemAnalysisResult res in result.systems)
            {
                ListViewItem item = new ListViewItem(new string[] { res.sys.Name, res.criticality.ToString(), res.availibility.ToString(), GetAvailibility(res.availibility), res.baseavailibility.ToString() });
                systemview.Items.Add(item);
            }

            foreach (EnvironmentAnalysisResult res in result.environments)
            {
                ListViewItem item = new ListViewItem(new string[] { res.env.name, res.crit.ToString(), res.availibility.ToString(),GetAvailibility(res.availibility),res.baseavailibility.ToString() });
                environmentview.Items.Add(item);
            }

            foreach (ProcessAnalysisResult res in result.processes)
            {            

                ListViewItem item = new ListViewItem(new string[] { res.process.Name, res.process.Criticality.ToString() ,res.availibility.ToString(), res.criticalavailibility.ToString(), GetAvailibility(res.criticalavailibility) });
                processview.Items.Add(item);
            }
        }

        public string GetAvailibility(double a)
        {

            string avail = "";

            if (AvailibilityToDaysPerYear(a) > 1)
            {
                avail += AvailibilityToDaysPerYear(a).ToString() + " days/year";
            }
            else if (AvailibilityToHoursPerYear(a) > 1)
            {
                avail += AvailibilityToHoursPerYear(a).ToString() + " hours/year";
            }
            else
            {
                avail += AvailibilityToMinutesPerYear(a).ToString() + " minutes/year";
            }

            return avail;


        }


        private void button1_Click(object sender, EventArgs e)
        {
            ((MainMenu)(this.Parent)).Text = "Enterprise Creator";
            ((MainMenu)(this.Parent)).SetUserControl(prev);
        }

        public double AvailibilityToDaysPerYear(double a)
        {
            return Math.Round(((1.0-a) * 365.0),3);
        }

        public double AvailibilityToHoursPerYear(double a)
        {
            return Math.Round(((1.0-a) * (365.0*24)),3);
        }

        public double AvailibilityToMinutesPerYear(double a)
        {
            return Math.Round(((1.0-a) * (365.0*24*60)),3);
        }        

        public string GetFullNamepath(EnterpriseRepresentation.Component comp)
        {
            string name = "";
            object obj = comp;

            while(true)
            {                
                if(obj.GetType().ToString().Equals("EnterpriseRepresentation.Component"))
                {
                    name =  ((EnterpriseRepresentation.Component)(obj)).Name + ":" + name;
                    obj = ((EnterpriseRepresentation.Component)(obj)).parent;
                }
                else
                {
                    break;
                }  
            }

            return name;
        }
    }
}
