using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using EnterpriseRepresentation;

namespace EnterpriseAnalysis
{
    public class EnterpriseAnalyzer
    {
        ComponentAnalyzer compcrit = new ComponentAnalyzer();
        EnvironmentAnalyzer envcrit = new EnvironmentAnalyzer();
        SystemAnalyzer syscrit = new SystemAnalyzer();
        ProcessAnalyzer processcrit = new ProcessAnalyzer();

        EnterpriseRepresentation.EnterpriseRepresentation ent;

        public EnterpriseAnalyzer(){}

        public AnalysisResult Analyze(EnterpriseRepresentation.EnterpriseRepresentation ent)
        {
            this.ent = ent;

            ArrayList comps = compcrit.GetComponentAnalysis(ent);
            ArrayList envs = envcrit.GetEnvironmentAnalysis(ent);
            ArrayList syss = syscrit.GetSystemAnalysis(ent);
            ArrayList process = processcrit.GetProcessAnalysis(ent);                     

            return new AnalysisResult(comps,syss,envs,process);
        }

    }
}
