using System;
using System.Collections;
using System.Runtime.Serialization;

namespace EnterpriseRepresentation
{
    [Serializable]
	public class BusinessFunction : BusinessFunctionObject, IFunctionNextAccessor
	{
		BusinessFunctionObject next;
		SystemOperation firstoperation = null;
		public BusinessProcess process;

		ArrayList tags = new ArrayList();
        public ArrayList stereotypes = new ArrayList();
		public string name;
		public string id;
        public double prob;

		public string ID
		{
			get{return id;}
			set{id = value;}
		}

		public string Name
		{
			get{return name;}
			set{name = value;}
		}

		public ArrayList Tags
		{
			get{return tags;}
		}

		public ArrayList Stereotypes
		{
			get{return stereotypes;}
			set{stereotypes = value;}
		}  
			
		public BusinessFunctionObject Next
		{
			get{return next;}
			set{next = value;}
		}

		public SystemOperation FirstOperation
		{
			get{return firstoperation;}
			set{firstoperation = value;}
		} 

		public BusinessFunction(string name, BusinessProcess process, string id)
		{
			this.id = id;
			this.process = process;
			this.name = name;
		}

		public void AddTag(TagValue tag){tags.Add(tag);}

		public string GetTagValue(string name)
		{
			foreach(TagValue tv in tags)
			{
				if(tv.tagname.Equals(name))
					return tv.tagvalue;
			}
			return null;
		}

        public void AddStereotype(string name) { stereotypes.Add(name); }

        public bool HasStereoType(string name)
        {    
            foreach (string s in stereotypes)
                {
                    if (s.Equals(name))
                    {
                        return true;
                    }
                }
            
            return false;
        }    
	}
}
