using System;
using System.Collections;
using System.Runtime.Serialization;

namespace EnterpriseRepresentation
{
    [Serializable]
	public class EnterpriseEntity
	{
		ArrayList tags = new ArrayList();
		public string name = "";
        public ArrayList stereotypes = new ArrayList();
		public string id = "";

		public string ID
		{
			get{return id;}
			set{id = value;}
		}

		public string Name
		{
			get{return name;}
			set{name = value;}
		}

		public ArrayList Tags
		{
			get{return tags;}
		}

		public ArrayList Stereotypes
		{
			get{return stereotypes;}
			set{stereotypes = value;}
		}  

		public EnterpriseEntity(){}

		public void AddTag(TagValue tag){tags.Add(tag);}

        public void AddStereotype(string name) { stereotypes.Add(name); }

        public bool HasStereoType(string name)
        {
            foreach (string s in stereotypes)
            {
                if (s.Equals(name))
                {
                    return true;
                }
            }

            return false;        
        }

        public void SetTagValue(string name, string value)
        {
            foreach (TagValue tv in tags)
            {
                if (tv.tagname.Equals(name))
                    tv.tagvalue = value;
            }           
        }

        public bool GotTagValue(string name)
        {
            foreach (TagValue tv in tags)
            {
                if (tv.tagname.Equals(name))
                    return true;
            }
            return false;
        }

		public string GetTagValue(string name)
		{
			foreach(TagValue tv in tags)
			{
				if(tv.tagname.Equals(name))
					return tv.tagvalue;
			}
			return null;
		}        
	}
}