using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace RiskAnalysis
{
    public partial class AddRiskDialogue : Form
    {
        RiskManager rm = new RiskManager();
        RiskManagerGUI rmg;
        bool FromAnalyzer;

        public AddRiskDialogue(RiskManagerGUI rmg)
        {
            InitializeComponent();
            this.rmg = rmg;
            FromAnalyzer = false;
        }

        public AddRiskDialogue()
        {
            InitializeComponent();
            FromAnalyzer = true;
        }


        public void SetName(string n)
        {
            name.Text = n;
        }

        public void SetDescription(string d)
        {
            desc.Text = d;
        }

        public enum Likelihood
        {
            Rare, Unlikely, Possible, Likely, Certain
        }

        public enum Consequence
        {
            Insignigigant, Minor, Moderate, Major, Catastrophic
        }

        private void AddRiskDialogue_Load(object sender, EventArgs e)
        {
            likeliehood.Items.Add(Likelihood.Certain);
            likeliehood.Items.Add(Likelihood.Likely);
            likeliehood.Items.Add(Likelihood.Possible);
            likeliehood.Items.Add(Likelihood.Unlikely);
            likeliehood.Items.Add(Likelihood.Rare);
            likeliehood.SelectedIndex = 0;

            consequence.Items.Add(Consequence.Insignigigant);
            consequence.Items.Add(Consequence.Minor);
            consequence.Items.Add(Consequence.Moderate);
            consequence.Items.Add(Consequence.Major);
            consequence.Items.Add(Consequence.Catastrophic);
            consequence.SelectedIndex = 0;
        }

        private void add_Click(object sender, EventArgs e)
        {
            Risk risk = new Risk();
            risk.name = name.Text;
            risk.description = desc.Text;
            risk.consequence = (Risk.Consequence)(consequence.SelectedItem);
            risk.likeliehood = (Risk.Likelihood)(likeliehood.SelectedItem);

            if (!FromAnalyzer)
            {
                rmg.rm.AddRisk(risk);
                rmg.DisplayRisks();
            }
            else
            {
                rm.AddRisk(risk);
                this.Close();
            }

        }
    }
}