using System;
using System.Collections;

namespace RiskAnalysis
{

	public class DiagramElement
	{
		public ArrayList Stereotypes
		{
			get{return stereotypes;}
			set{stereotypes=(ArrayList)value;}
		}

		public string Name
		{
			get{return name;}
			set{name = value;}
		}

		public string ID
		{
			get{return id;}
			set{id = value;}
		}
		
		public string name = "";
		public string id = "";
		public ArrayList stereotypes = new ArrayList();
		public ArrayList tags = new ArrayList();

		public DiagramElement()
        {
        }

		public void AddTag(TagValue tag)
		{
			tags.Add(tag);
		}

        public void AddStereotype(Stereotype s)
        {
            stereotypes.Add(s);
        }

        public bool GotTagName(string name)
        {
            foreach (TagValue t in tags)
            {
                if (t.tagname.Equals(name))
                {
                    return true;
                }
            }

            return false;
        }

		public string GetTagValue(string name)
		{
			foreach(TagValue tv in tags)
			{
				if(tv.tagname.Equals(name))
					return tv.tagvalue;
			}
			return null;
		}

		
	}
}
