using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Xml;

namespace RiskAnalysis
{
    public class ReportMaker
    {
        string output;

        public ReportMaker()
        {
            output += "<?xml version=\"1.0\"?><?mso-application progid=\"Word.Document\"?><w:wordDocument xmlns:w=\"http://schemas.microsoft.com/office/word/2003/wordml\"><w:body>";
        }

        public void AppendDataTable(DataTable datatable)
        {
            
            output += "<w:tbl>";


            output += "<w:tr>";

            for (int i = 0; i < datatable.Columns.Count; i++)
            {
                output += "<w:tc>";
                output += "<w:p><w:r>";
                output += "<w:t>" + datatable.Columns[i].ColumnName + "</w:t>";
                output += "</w:r></w:p>";
                output += "</w:tc>";
            }

            output += "</w:tr>";

            foreach(DataRow datarow in datatable.Rows)
            {
                output += "<w:tr>";
                
                for(int i=0; i<datarow.ItemArray.Length;i++)
                {
                    output += "<w:tc>";
                    output += "<w:p><w:r>";
                    output += "<w:t>" + ((string)(datarow.ItemArray.GetValue(i))) +"</w:t>";
                    output += "</w:r></w:p>";
                    output += "</w:tc>";
                }

                output += "</w:tr>";
            }
        
        output += "</w:tbl>";

        }

        public void AppendBreak()
        {
            output += "<w:br w:type=\"text-wrapping\"/>";
        }
        public void AppendLine(string tekst)
        {
            output += "<w:p> <w:r> <w:t>" + tekst + "</w:t> </w:r> </w:p>";
        }

        public void SaveReport(string filename)
        {
            output += "</w:body></w:wordDocument>";
            XmlDocument doc = new XmlDocument();
            doc.LoadXml(output);
            doc.Save(filename);           
        }

    }
}
