using System;
using System.Collections.Generic;
using System.Text;
using System.Data.OleDb;
using System.Data;
using System.Collections;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace RiskAnalysis
{
    public class RiskManager
    {

        ArrayList risks = new ArrayList();
        string StartUpPath = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetEntryAssembly().Location);
        string filename;     

        public RiskManager()
        {
            filename = StartUpPath + "\\risk.dat";
            risks = GetRisks();
        }

        public void AddRisk(Risk risk)
        {
            risks.Add(risk);
            SaveRisks();        
        }

        public void RemoveRisk(Risk risk)
        {
            risks.Remove(risk);
            SaveRisks();
        }
        
        private void SaveRisks()
        {
            
            FileStream fStream = new FileStream(filename, FileMode.Create);
            BinaryFormatter binFormat = new BinaryFormatter();

            try
            {                
                binFormat.Serialize(fStream, risks);
            }
            
            catch
            {  }
            
            finally
            {
                fStream.Close();
            }

        }

        public ArrayList GetRisks()
        {
            FileStream fStream = null;
            
            if (File.Exists(filename))
            {
                try
                {
                    fStream = new FileStream(filename, FileMode.Open);
                    BinaryFormatter binFormat = new BinaryFormatter();
                    risks = (ArrayList)binFormat.Deserialize(fStream);

                    
                }
                catch
                {
                   
                }
                finally
                {
                    fStream.Close();
                }
            }

            if (risks == null)
                risks = new ArrayList();

            return risks;


        }







    }

      
}
